package com.jscape.inet.ssh.protocol.v2.marshaling;

import com.jscape.inet.ssh.protocol.messages.Message;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.MpintCodec;
import com.jscape.inet.ssh.protocol.v2.messages.SshMsgKexDhGexInit;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.math.BigInteger;

/**
 * @author Alex Usun
 */
public class SshMsgKexDhGexInitCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        BigInteger e = MpintCodec.readValue(in);

        return new SshMsgKexDhGexInit(e);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshMsgKexDhGexInit message = (SshMsgKexDhGexInit) value;
        MpintCodec.writeValue(message.e, out);
    }
}
